<?php
/**
 * Free Canvas
 *
 * @package    Free Canvas
 * @subpackage Free Canvas Ajax
/*  Copyright (c) 2020- Katsushi Kawamori (email : dodesyoswift312@gmail.com)
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$freecanvasajax = new FreeCanvasAjax();

/** ==================================================
 * Scoring Ajax
 */
class FreeCanvasAjax {

	/** ==================================================
	 * Construct
	 *
	 * @since 1.00
	 */
	public function __construct() {

		$action1 = 'free-canvas-ajax-action';
		add_action( 'wp_ajax_' . $action1, array( $this, 'freecanvas_callback' ) );
		add_action( 'wp_ajax_nopriv_' . $action1, array( $this, 'freecanvas_callback' ) );

	}

	/** ==================================================
	 * Canvas Callback
	 *
	 * @param object $image_data  image_data.
	 * @since 1.00
	 */
	public function freecanvas_callback( $image_data = null ) {

		$action1 = 'free-canvas-ajax-action';
		if ( check_ajax_referer( $action1, 'nonce', false ) ) {
			if ( isset( $_POST['name'] ) && ! empty( $_POST['name'] ) ) {
				$canvas_name = sanitize_text_field( wp_unslash( $_POST['name'] ) );
			} else {
				$canvas_name = null;
			}
			if ( isset( $_POST['image'] ) && ! empty( $_POST['image'] ) ) {
				$image_data = base64_decode( sanitize_text_field( wp_unslash( $_POST['image'] ) ) );
			}
			if ( ! is_null( $image_data ) ) {
				$image_data = apply_filters( 'free_canvas_save', $image_data, $canvas_name );
				if ( is_wp_error( $image_data ) ) {
					return $image_data;
				}
			}
		} else {
			status_header( '403' );
			echo 'Forbidden';
		}

		wp_die();

	}

}

